const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const customers = sequelize.define(
    'customers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

customer_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"individual",


"company"

        ],

      },

email: {
        type: DataTypes.TEXT,
      
      

      },

phone: {
        type: DataTypes.TEXT,
      
      

      },

address: {
        type: DataTypes.TEXT,
      
      

      },

city: {
        type: DataTypes.TEXT,
      
      

      },

country: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  customers.associate = (db) => {

    db.customers.belongsToMany(db.tags, {
      as: 'tags',
      foreignKey: {
        name: 'customers_tagsId',
      },
      constraints: false,
      through: 'customersTagsTags',
    });

    db.customers.belongsToMany(db.tags, {
      as: 'tags_filter',
      foreignKey: {
        name: 'customers_tagsId',
      },
      constraints: false,
      through: 'customersTagsTags',
    });


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

















    db.customers.hasMany(db.sales_orders, {
      as: 'sales_orders_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });



    db.customers.hasMany(db.invoices, {
      as: 'invoices_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });


    db.customers.hasMany(db.payments, {
      as: 'payments_customer',
      foreignKey: {
          name: 'customerId',
      },
      constraints: false,
    });













//end loop



    db.customers.belongsTo(db.companies, {
      as: 'company',
      foreignKey: {
        name: 'companyId',
      },
      constraints: false,
    });




    db.customers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.customers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return customers;
};


